'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _enzyme = require('enzyme');

var _asyncComponent = require('../asyncComponent');

var _asyncComponent2 = _interopRequireDefault(_asyncComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('asyncComponent', function () {
  var contextStub = {
    asyncComponents: {
      getNextId: function getNextId() {
        return 1;
      },
      registerComponent: function registerComponent() {
        return undefined;
      },
      getComponent: function getComponent() {
        return undefined;
      },
      registerError: function registerError() {
        return undefined;
      },
      getError: function getError() {
        return undefined;
      }
    }
  };

  it('should handle unmounting ensuring that resolved promises do not call setState', function () {
    var resolveDelay = 10;
    var Bob = (0, _asyncComponent2.default)({
      resolve: function resolve() {
        return new Promise(function (resolve) {
          return setTimeout(function () {
            return resolve(function () {
              return _react2.default.createElement(
                'div',
                null,
                'bob'
              );
            });
          }, resolveDelay);
        });
      }
    });
    var setStateSpy = _sinon2.default.spy(Bob.prototype, 'setState');
    var renderWrapper = (0, _enzyme.mount)(_react2.default.createElement(Bob, null), { context: contextStub });
    expect(setStateSpy.callCount).toEqual(0);
    renderWrapper.unmount();
    return new Promise(function (resolve) {
      return setTimeout(resolve, resolveDelay + 2);
    }).then(function () {
      return expect(setStateSpy.callCount).toEqual(0);
    });
  });
});